#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "iup.h"
#include "cd.h"
#include "iupcontrols.h"


static int nlines_cb(Ihandle* h) {
   return 8;
}

static int ncols_cb(Ihandle* h) {
   return 8;
}

static int height_cb(Ihandle* h, int i) {
   return 50;
}

static int width_cb(Ihandle* h, int j) {
   return 50;
}

static int draw_cb(Ihandle* h, int i, int j, int xmin, int xmax,
int ymin, int ymax) {

  if (((i%2) && (j%2)) || (((i+1)%2) && ((j+1)%2))) cdForeground(CD_WHITE);
  else cdForeground(CD_BLACK);
  cdBox(xmin, xmax, ymin, ymax);

  return IUP_DEFAULT;
}

static Ihandle* create(void) {
   Ihandle* cells = IupCells();
   
   IupSetAttribute(cells, IUP_DRAW_CB, "draw_cb");
   IupSetAttribute(cells, IUP_WIDTH_CB, "width_cb");
   IupSetAttribute(cells, IUP_HEIGHT_CB, "height_cb");
   IupSetAttribute(cells, IUP_NLINES_CB, "nlines_cb");
   IupSetAttribute(cells, IUP_NCOLS_CB, "ncols_cb");
   
   IupSetFunction("draw_cb", (Icallback)draw_cb);
   IupSetFunction("ncols_cb", (Icallback)ncols_cb);
   IupSetFunction("nlines_cb", (Icallback)nlines_cb);
   IupSetFunction("width_cb", (Icallback)width_cb);
   IupSetFunction("height_cb", (Icallback)height_cb);

   return cells;
}

/* Main program */
int main(void) {
   Ihandle* dlg = NULL;
   Ihandle* cells = NULL;

   IupOpen();
   IupControlsOpen();

   cells = create();
   dlg = IupDialog(cells) ;

   IupSetAttribute(dlg,IUP_RASTERSIZE,"400x400");
   IupSetAttribute(dlg,IUP_TITLE,"IupCells");

   IupShowXY(dlg,IUP_CENTER,IUP_CENTER) ;
   IupMainLoop() ;
   IupDestroy(dlg);
   IupControlsClose();
   IupClose() ;
   return 0 ;
}
