--IupVal Example in IupLua 
--Creates two Valuator controls, exemplifying the two possible types. When manipulating the Valuator, the label's value changes.

function fbuttonpress (self)
  if (self.type == "VERTICAL") then
    lbl_v.fgcolor="255 0 0"
  else
    lbl_h.fgcolor="255 0 0"
  end
  return IUP_DEFAULT
end

function fbuttonrelease (self)
  if (self.type == "VERTICAL") then
    lbl_v.fgcolor="0 0 0"
  else
    lbl_h.fgcolor="0 0 0"
  end
  return IUP_DEFAULT
end

function fmousemove(self, val)
  local buffer = "IUP_VALUE="..format('%.2f', val)
  if (self.type == "HORIZONTAL") then
    lbl_h.title=buffer
  else
    lbl_v.title=buffer
  end
  return IUP_DEFAULT
end

val_v = iupval{
		"VERTICAL";
		min=0,
		max=1,
		value="0.3",
		mousemove=fmousemove,
		buttonpress=fbuttonpress,
		buttonrelease=fbuttonrelease
	}

lbl_v = iuplabel {title="IUP_VALUE=   ", size=70, type="1"}

val_h = iupval{"HORIZONTAL";
		min=0,
		max=1,
		value=0,
		mousemove=fmousemove,
		buttonpress=fbuttonpress,
		buttonrelease=fbuttonrelease
	}
lbl_h = iuplabel {title="IUP_VALUE=   ", size=70, type="2"}

dlg_val = iupdialog
{
	iuphbox
	{
		iupframe
		{
			iupvbox
			{
				val_v,
				lbl_v
			}
		},
		iupframe
		{
			iupvbox
			{
				val_h,
				lbl_h
			}
		}
	};
	title="Teste do Valuator"
}

dlg_val:show()

