--IupMenu Example in IupLua 
--Creates a dialog with a menu with two submenus. 

-- IupMenu example

-- Creates a text, sets its value and turns on text readonly mode 
text = iuptext {readonly = "YES", value = "Selecting show or hide will affect this text"}

-- Creates items, sets its shortcut keys and deactivates edit item
item_show = iupitem {title = "Show", key = "S"}
item_hide = iupitem {title = "Hide", key = "H"}
item_edit = iupitem {title = "Edit", key = "E", active = "NO"}
item_exit = iupitem {title = "Exit", key = "x"}

-- Creates two menus
menu_file = iupmenu {item_exit}
menu_text = iupmenu {item_show, item_hide, item_edit}

-- Creates two submenus
submenu_file = iupsubmenu {menu_file; title = "File"}
submenu_text = iupsubmenu {menu_text; title = "Text"}

-- Creates main menu with two submenus
menu = iupmenu {submenu_file, submenu_text}
                                
-- Creates dialog with a text, sets its title and associates a menu to it 
dlg = iupdialog {text
      ; title ="IupMenu Example", menu = menu}

-- Shows dialog in the center of the screen 
dlg:showxy (IUP_CENTER,IUP_CENTER)

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Show item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Shows the text                                                             --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_show:action ()
  text.visible = "YES"
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Hide item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Hides the text                                                             --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_hide:action ()
  text.visible = "NO"
  
  return IUP_DEFAULT
end


--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Show text callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Exits the program                                                          --
--                                                                            --
-- Value returned:                                                            --
--Iup_DEFAULT                                                                 --
--------------------------------------------------------------------------------
function item_exit:action ()
  return IUP_CLOSE
end