--IupSeparator Example in IupLua 
--Creates a dialog with a menu and some items. A IupSeparator was used to separate the menu items. 

-- IupSeparator example

-- Creates a text, sets its value and turns on text readonly mode 
text = iuptext {value = "This text is here only to compose", expand = "YES"}

-- Creates six items
item_new = iupitem {title = "New"}
item_open = iupitem {title = "Open"}
item_close = iupitem {title = "Close"}
item_pagesetup = iupitem {title = "Page Setup"}
item_print = iupitem {title = "Print"}
item_exit = iupitem {title = "Exit"}

-- Creates file menus
menu_file = iupmenu {item_new, item_open, item_close, iupseparator{}, item_pagesetup, item_print, iupseparator{}, item_exit }

-- Creates file submenus
submenu_file = iupsubmenu {menu_file; title = "File"}

-- Creates main menu with file submenu
menu = iupmenu {submenu_file}
                                
-- Creates dialog with a text, sets its title and associates a menu to it 
dlg = iupdialog {text
      ; title ="IupSeparator Example", menu = menu, size = "QUARTERxEIGHTH"}

-- Shows dialog in the center of the screen 
dlg:showxy (IUP_CENTER,IUP_CENTER)

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Show message                                                               --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function show_message ()
  IupMessage ("Warning", "This item performs no operation\nIt is here only to compose") ;
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- New item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_new:action ()
  show_message ()
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Open item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_open:action ()
  show_message ()
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Close item callback                                                        --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_close:action ()
  show_message ()
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Page Setup item callback                                                   --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_pagesetup:action ()
  show_message ()
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Print                                                                      --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that the this item performs no operation            --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_print:action ()
  show_message ()
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Exit item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Exits the program                                                          --
--                                                                            --
-- Value returned:                                                            --
-- IUP_CLOSE                                                                  --
--------------------------------------------------------------------------------
function item_exit:action ()
  return IUP_CLOSE
end