--IupSubmenu Example in IupLua 
--Creates a dialog with a menu with three submenus. One of the submenus has a submenu, which has another submenu. 

-- IupSubmenu example

-- Creates a text, sets its value and turns on text readonly mode 
text = iuptext {value = "This text is here only to compose", expand = "YES"}

-- Creates items of menu file
item_new = iupitem {title = "New"}
item_open = iupitem {title = "Open"}
item_close = iupitem {title = "Close"}
item_exit = iupitem {title = "Exit"}

-- Creates items of menu edit
item_copy = iupitem {title = "Copy"}
item_paste = iupitem {title = "Paste"}

-- Creates items for menu triangle
item_equilateral = iupitem {title = "Equilateral"}
item_isoceles = iupitem {title = "Isoceles"}
item_scalenus = iupitem {title = "Scalenus"}

-- Creates menu triangle
menu_triangle = iupmenu {item_equilateral, item_isoceles, item_scalenus}

-- Creates submenu triangle
submenu_triangle = iupsubmenu {menu_triangle; title = "Triangle"}

-- Creates items of menu create
item_line = iupitem {title = "Line"}
item_circle = iupitem {title = "Circle"}

-- Creates menu create
menu_create = iupmenu {item_line, item_circle, submenu_triangle}

-- Creates submenu create
submenu_create = iupsubmenu {menu_create; title = "Create"}

-- Creates items of menu help
item_help = iupitem {title = "Help"}

-- Creates menus of the main menu
menu_file = iupmenu {item_new, item_open, item_close, iupseparator{}, item_exit }
menu_edit = iupmenu {item_copy, item_paste, iupseparator{}, submenu_create}
menu_help = iupmenu {item_help}

-- Creates submenus of the main menu
submenu_file = iupsubmenu {menu_file; title = "File"}
submenu_edit = iupsubmenu {menu_edit; title = "Edit"}
submenu_help = iupsubmenu {menu_help; title = "Help"}

-- Creates main menu with file submenu
menu = iupmenu {submenu_file, submenu_edit, submenu_help}
                                
-- Creates dialog with a text, sets its title and associates a menu to it 
dlg = iupdialog {text
      ; title ="IupSubmenu Example", menu = menu, size = "QUARTERxEIGHTH"}

-- Shows dialog in the center of the screen 
dlg:showxy (IUP_CENTER,IUP_CENTER)

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Print                                                                      --
--                                                                            --
-- Description:                                                               --
-- Shows a message saying that only Help and Exit items performs an operation --
--                                                                            --
-- Value returned:                                                            --
-- IUP_DEFAULT                                                                --
--------------------------------------------------------------------------------
function item_help:action ()
  IupMessage ("Warning", "Only Help and Exit items performs an operation")
  
  return IUP_DEFAULT
end

--------------------------------------------------------------------------------
-- Function:                                                                  --
-- Exit item callback                                                         --
--                                                                            --
-- Description:                                                               --
-- Exits the program                                                          --
--                                                                            --
-- Value returned:                                                            --
-- IUP_CLOSE                                                                  --
--------------------------------------------------------------------------------
function item_exit:action ()
  return IUP_CLOSE
end