--IupVbox Example in IupLua 
--Creates a dialog with buttons placed one above the other, showing the organization possibilities of the elements inside a vbox. The IUP_ALIGNMENT attribute is explored in all its possibilities to obtain the effects. The attributes IUP_GAP, IUP_MARGIN and IUP_SIZE are also tested. 

-- IupVbox Example

-- Creates frame 1
frm_1 = iupframe
{
  iuphbox
  {
    iupfill {},
    iupvbox
    {
      iupbutton {title = "1", size = "20x30", action = ""},
      iupbutton {title = "2", size = "30x30", action = ""},
      iupbutton {title = "3", size = "40x30", action = ""} ;
      -- Sets alignment and gap of vbox
      alignment = IUP_ALEFT, gap = 10
    },
    iupfill {}
  } ;
  -- Sets title of frame 1
  title = "ALIGNMENT = ALEFT, GAP = 10"
}

-- Creates frame 2
frm_2 = iupframe
{
  iuphbox
  {
    iupfill {},
    iupvbox
    {
      iupbutton {title = "1", size = "20x30", action = ""},
      iupbutton {title = "2", size = "30x30", action = ""},
      iupbutton {title = "3", size = "40x30", action = ""} ;
      -- Sets alignment and margin of vbox
      alignment = IUP_ACENTER, margin = 15
    },
    iupfill {}
  } ;
  -- Sets title of frame 1
  title = "ALIGNMENT = ACENTER, MARGIN = 15"
}

-- Creates frame 3
frm_3 = iupframe
{
  iuphbox
  {
    iupfill {},
    iupvbox
    {
      iupbutton {title = "1", size = "20x30", action = ""},
      iupbutton {title = "2", size = "30x30", action = ""},
      iupbutton {title = "3", size = "40x30", action = ""} ;
      -- Sets alignment and size of vbox
      alignment = IUP_ARIGHT, size = 20
    },
    iupfill {}
  } ;
  -- Sets title of frame 3
  title = "ALIGNMENT = ARIGHT, SIZE = 20"
}

dlg = iupdialog
{
  iupvbox
  {
    frm_1,
    frm_2,
    frm_3
  } ;
  title = "IupVbox Example", size = "QUARTER"
}

-- Shows dialog in the center of the screen
dlg:showxy (IUP_CENTER, IUP_CENTER)