--IupZbox Example in IupLua 
--An application of a zbox could be a program requesting several entries from the user according to a previous selection. In this example, a list of possible layouts ,each one consisting of an element, is presented, and according to the selected option the dialog below the list is changed. 

-- IupZbox Example 

fill = iupfill {}
text = iuptext {value = "Enter your text here", expand = "YES"}
lbl  = iuplabel {title = "This element is a label"}
btn  = iupbutton {title = "This button does nothing"}
zbox = iupzbox
{
  fill,
  text,
  lbl,
  btn ;
  alignment = IUP_ACENTER, value=text
}

list = iuplist { "fill", "text", "lbl", "btn"; value="2"}
ilist = {fill, text, lbl, btn}

function list:action (t, o, selected)
  if selected == 1 then
    -- Sets the value of the zbox to the selected element 
    zbox.value=ilist[o]
  end
  
  return IUP_DEFAULT
end

frm = iupframe
{
  iuphbox
  {
    iupfill{},
    list,
    iupfill{}
  } ;
  title = "Select an element"
}

dlg = iupdialog
{
  iupvbox
  {
    frm,
    zbox
  } ;
  size = "QUARTER",
  title = "IupZbox Example"
}

dlg:showxy (0, 0)
